#include <windows.h>
#include "resource\resource.h"
#include "loadmusic\loadmusic.h"
#include "lib\minifmod.h"

//======================Handles================================================//
HINSTANCE hInst;             // main function handler
FMUSIC_MODULE *mod;          // fmod music handler
#define WIN32_LEAN_AND_MEAN  // this will assume smaller exe

//====================MAIN KEYGEN DIALOG==========================================//
BOOL CALLBACK DialogProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) // what are we doing ?
	{ 	 
		// This Window Message is the heart of the dialog //
		//================================================//
		case WM_INITDIALOG: 
		{
			// Autoplay effect!!
			if (mod == NULL) // mod handle is free? (thouh it will work fine with other loaded audio devices)
			{
				// We defined our music file to be loaded in LoadMusic.cpp //
				//=============================================================//
				loadmusic(); // Call & set ready memory to load the music
				if(!FSOUND_Init(44100, 0)) // intialize memory for sound
				{
							break;
				}
				mod = FMUSIC_LoadSong(NULL, NULL); // handle = LoadSong() 
				FMUSIC_PlaySong(mod); // Play it (from memory)
			}
			return true;
		}
		break;

		case WM_LBUTTONDOWN: // moving dialog trick with mouse
		{
			ReleaseCapture(); // see above :-)
			SendMessage(hWnd,WM_NCLBUTTONDOWN,HTCAPTION,0); // see above
		}
		break;

		case WM_PAINT: // constantly painting the window
		{
			return false;
		}
		break;

		case WM_COMMAND: // Controling the Buttons
		{
			switch (LOWORD(wParam)) // what we pressed on?
			{
				case IDC_NAME:
				case IDC_GENERATE: // Generage Button is pressed
				{
					char name[256];
					GetDlgItemText(hWnd,IDC_NAME,name,256);
				    SetDlgItemText(hWnd,IDC_SERIAL,name);
				} 
				break;
				
				case IDC_ABOUT: // About Button is pressed
				{
					MessageBox(hWnd,"This Code is Coded by Ben and [goofy] of FSS 2002","Keygen with Music template",MB_OK);
				}
				break;

				case IDC_Play: // Play Button is pressed
				{
					if (mod == NULL) // mod handle is free? (thouh it will work fine with other loaded audio devices)
					{
						// We defined our music file to be loaded in LoadMusic.cpp //
						//=============================================================//
						loadmusic(); // Call & set ready memory to load the music
						if(!FSOUND_Init(44100, 0)) // intialize memory for sound
						{
							break;
						}
						mod = FMUSIC_LoadSong(NULL, NULL); // handle = LoadSong() 
						FMUSIC_PlaySong(mod); // Play it (from memory)
					}
				}
				break;

				case IDC_Stop: // Stop Button is pressed
				{
					if (mod != NULL) // handle is loaded (playing)?
					{
						FMUSIC_FreeSong(mod); // Free memory (handle)
						FSOUND_Close(); // Close it (stop it from playing)
						mod=NULL; // make handle to be Free again
					}
				}
				break;

			}
			break;

			case WM_CLOSE: // We colsing the Dialog
			{
				if (mod != NULL) // music is on?
				{
					FMUSIC_FreeSong(mod); // Free it from memory (the handle - "mod")
					FSOUND_Close(); // Close Music
				}
				EndDialog(hWnd,0); // Kill Dialog
			}
			break;
		}
		break;
	}
	return 0;
}

//===========================MAIN FUNCTION-WIN32 STARTING POINT========================================//
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
	hInst=hInstance;
	DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), NULL, (DLGPROC)DialogProc,0);
	return 0;
}
//======================================================================================================//